zoukankan      html  css  js  c++  java
  • 454. 4Sum II

    Given four lists A, B, C, D of integer values, compute how many tuples (i, j, k, l) there are such that A[i] + B[j] + C[k] + D[l] is zero.

    To make problem a bit easier, all A, B, C, D have same length of N where 0 ≤ N ≤ 500. All integers are in the range of -228 to 228 - 1 and the result is guaranteed to be at most 231 - 1.

    Example:

    Input:
    A = [ 1, 2]
    B = [-2,-1]
    C = [-1, 2]
    D = [ 0, 2]
    
    Output:
    2
    
    Explanation:
    The two tuples are:
    1. (0, 0, 0, 1) -> A[0] + B[0] + C[0] + D[1] = 1 + (-2) + (-1) + 2 = 0
    2. (1, 1, 0, 0) -> A[1] + B[1] + C[0] + D[0] = 2 + (-1) + (-1) + 0 = 0
    class Solution {
        public int fourSumCount(int[] A, int[] B, int[] C, int[] D) {
            int res = 0;
            int le = A.length;
            if(le == 0) return res;
            Map<Integer, Integer> map = new HashMap();
            
            for(int i = 0; i < le; i++){
                for(int j = 0; j < le; j++){
                    int t = - A[i] - B[j];
                    map.put(t, map.getOrDefault(t, 0) + 1);
                }
            }
            for(int i = 0; i < le; i++){
                for(int j = 0; j < le; j++){
                    int t = C[i] + D[j];
                    if(map.containsKey(t)) res += map.get(t);
                }
            }
            return res;
        }
    }

    比4sum简单,因为不用考虑到重复元素(元素重复但是下标不重复)

    解法很巧妙,用hashmap存放前两个数组每个pair和出现的次数,

    然后在第三第四个数组中找有无一样的值,如果有就加上该次数,因为次数是AB数组独特的所以可以直接加。

  • 相关阅读:
    Day1-CSS-下拉菜单
    scau 1138 代码等式
    SCAU-1076 K尾相等数
    勾股数专题-SCAU-1079 三角形-18203 神奇的勾股数(原创)
    SCAU-1144 数星星-HDU-1166-树状数组的应用
    NodeJs Fs模块
    Node核心模块
    flutter环境配置
    纯CSS制作图形效果
    CSS3选择器
  • 原文地址:https://www.cnblogs.com/wentiliangkaihua/p/11847925.html
Copyright © 2011-2022 走看看